; semi-parallel assembly code for N element floating point dot product
; using LDDW
; A4 and B4 contain pointers to arrays of floats
; A6 contains an integer with N 
			.def 	_dotproduct3

_dotproduct3:
			MV		.S1		A6, A1		; copy count to register A1
||			ZERO	.L1		A8			; zero even accumulator
||			ZERO	.L2		B8			; zero odd accumulator
LOOP:
			LDDW	.D1		*A4++, A3:A2	; get element from first array
||			LDDW	.D2		*B4++, B7:B6	; get element from second array
			SUB		.S1		A1, 2, A1	; decrement counter (NOTE DECREMENT BY 2)
			NOP		2					; wait for data
	[A1]	B		.S2		LOOP		; conditional branch
			MPYSP	.M1x	A2, B6, A7	; multiply 
||			MPYSP	.M2x	A3, B7, B9	; multiply 
			NOP	    3					; wait for result
			ADDSP	.L1		A7, A8, A8	; accumulate
||			ADDSP	.L2		B9, B8, B8	; accumulate
			; conditional branch occurs here
			NOP
			B		B3					; branch back to calling function
			NOP		1
			ADDSP	.L1x	A8, B8, A4	; put final result in A4
			NOP		3

			.end